import { pEvent } from 'p-event';
import pWaitFor from 'p-wait-for';
import { Components } from '@libp2p/components';
import { createEd25519PeerId } from '@libp2p/peer-id-factory';
import { mockConnectionManager, mockRegistrar, mockNetwork } from '@libp2p/interface-mocks';
export async function waitForSubscriptionUpdate(a, b) {
    await pWaitFor(async () => {
        const event = await pEvent(a, 'subscription-change');
        return event.detail.peerId.equals(b);
    });
}
export async function createComponents() {
    const components = new Components({
        peerId: await createEd25519PeerId(),
        registrar: mockRegistrar(),
        connectionManager: mockConnectionManager()
    });
    mockNetwork.addNode(components);
    return components;
}
//# sourceMappingURL=utils.js.map